<?php

require_once __DIR__.'/constants.php';

if ($_SERVER['REQUEST_METHOD'] !== 'POST') {

    output($status_code_ArgumentInvalidOrMissing, "only post method is supported");
    exit(1);
}

#$remoteIp = $_SERVER['REMOTE_ADDR'];


#request was allowed

#=============================================== now read the config

$configContent = file_get_contents($jsonConfigFile, TRUE);

if ($configContent === FALSE) {
    output($status_code_InternalServerError, "could not read config file...");
    exit(1);
}

$config = json_decode($configContent, TRUE);

if ($config === NULL) {
    output($status_code_InternalServerError, "could not decode config");
    exit(1);
}

if (isset($config['useConfigFromDb']) === FALSE || (isset($config['useConfigFromDb']) && $config['useConfigFromDb'] === FALSE)) {
    //don't use config from db so just return
    return $config;
}


//get the config from the db

include_once __DIR__.'/sqlHelper.php';


$conn = connectToDb($config['dbConfigServer'], $config['dbConfigName'], $config['dbConfigUser'], $config['dbConfigPw']);

if ($conn === NULL) {
    output($status_code_DbIssue, 'could not connect to config db');
    exit(1);
}


$sql = "SELECT * FROM `" . $config['dbConfigTableName'] . "`;";
$allRows = executeSqlAndReturnValue($conn, $sql, []);

if (count($allRows) === 0) {
    output($status_code_InternalServerError, 'could not find config in db');
    exit(1);
}

$row = $allRows[0];

$config['workingDirFullPath'] = $row['workingDirFullPath'];

$config[$s_arg_hardTimeoutInMs] = $row[$s_arg_hardTimeoutInMs];
$config[$s_arg_hardCompileTimeoutInMs] = $row[$s_arg_hardCompileTimeoutInMs];
$config[$s_arg_hardMemoryLimitInKb] = $row[$s_arg_hardMemoryLimitInKb];
$config[$s_arg_hardDiskSpaceLimitInKb] = $row[$s_arg_hardDiskSpaceLimitInKb];

$config['maxParallelTests'] = $row['maxParallelTests'];
$config['maxNumberOfTestsWithOneRequest'] = $row['maxNumberOfTestsWithOneRequest'];
$config['runner'] = $row['runner'];
$config['maxLinesToRead'] = $row['maxLinesToRead'];

$config['maxErrLinesToRead'] = $row['maxErrLinesToRead'];
$config['maxLinesToWrite'] = $row['maxLinesToWrite'];
$config['showTestRunnerDebugOutput'] = $row['showTestRunnerDebugOutput'] === '1';
$config['environmentVars'] = $row['environmentVars'];

//parse environmentVars
if (isset($config['environmentVars'])) {
    $keyValuePairs = preg_split("/\r\n|\n/", $config['environmentVars']);
    $config['environmentVarsParsed'] = $keyValuePairs;
} else {
    $config['environmentVarsParsed'] = NULL;
}

return $config;